Unit ZF10R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTZF10_p;

procedure ZF10R(F :Func_F1; var A :Real; var B :Real; EPS :Real;
                NDIG :Integer; var ITMAX :Integer; var ROOT :Real;
                var IERR :Integer);

implementation

procedure ZF10R(F :Func_F1; var A :Real; var B :Real; EPS :Real;
                NDIG :Integer; var ITMAX :Integer; var ROOT :Real;
                var IERR :Integer);
var
IO,NSIG :Integer;
A1,B1,C,D,E,S,P,R,RM,RONE,Q,FA,FB,FC,FBC,T,TOL,TEMP :Real;
const
ZERO :Real = 0.0;
HALF :Real = 0.5;
ONE :Real = 1.0;
THREE :Real = 3.0;
TEN :Real = 10.0;
SYS051 :Real = 1.192093E-07;
NDMAX :Integer = 6;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22;
begin
A1 := A;
B1 := B;
NSIG := NDIG;
IO := 0;
IERR := 0;
if ( NDIG = 0 ) 
 then NSIG := NDMAX;
T := Power(TEN,-NSIG);
FA := F(A);
FB := F(B);
if ( FA*FB ) < 0
 then goto _1
 else if ( FA*FB ) > 0
       then goto _20
       else goto _19;
_1:
C := A;
FC := FA;
D := B-A;
E := D;
_2:
if ( Abs(FC) >= Abs(FB) ) 
 then goto _3;
A := B;
B := C;
C := A;
FA := FB;
FB := FC;
FC := FA;
_3:
TOL := EMax1(T,(SYS051+SYS051)*Abs(B));
if ( Abs(FB) <= Abs(EPS) ) 
 then goto _16;
RM := (C-B)*HALF;
if ( Abs(RM) >= TOL ) 
 then goto _4;
goto _16;
_4:
if ( Abs(E) < TOL ) or ( Abs(FA) <= Abs(FB) ) 
 then goto _12;
S := FB/FA;
if ( A-C ) < 0
 then goto _6
 else if ( A-C ) > 0
       then goto _6
       else goto _5;
_5:
P := (RM+RM)*S;
Q := ONE-S;
goto _7;
_6:
Q := FA/FC;
R := FB/FC;
RONE := R-ONE;
P := S*((RM+RM)*Q*(Q-R)-(B-A)*RONE);
Q := (Q-ONE)*RONE*(S-ONE);
_7:
if ( P-ZERO ) < 0
 then goto _8
 else if ( P-ZERO ) > 0
       then goto _9
       else goto _8;
_8:
P := -P;
goto _10;
_9:
Q := -Q;
_10:
S := E;
E := D;
if ( (P+P) >= THREE*RM*Q-Abs(TOL*Q) ) and ( P >= Abs(HALF*S*
     Q) ) 
 then goto _11;
D := P/Q;
goto _13;
_11:
E := RM;
D := E;
goto _13;
_12:
E := RM;
D := E;
_13:
A := B;
FA := FB;
if ( Abs(D) > TOL ) 
 then goto _14;
TEMP := -TOL;
if ( RM > ZERO ) 
 then TEMP := TOL;
goto _15;
_14:
TEMP := D;
_15:
IO := IO+1;
if ( IO <= ITMAX ) 
 then goto _18;
IERR := 65;
_16:
ITMAX := IO;
if ( IERR <> 0 ) 
 then goto _21;
_17:
ROOT := B;
B := B1;
A := A1;
goto _22;
_18:
B := B+TEMP;
FB := F(B);
FBC := FB*FC;
if ( FBC ) < 0
 then goto _2
 else if ( FBC ) > 0
       then goto _1
       else goto _2;
_19:
if ( FA = ZERO ) 
 then B := A;
goto _16;
_20:
IERR := 66;
IO := 1;
goto _16;
_21:
UTZF10(IERR,10);
goto _17;
_22:
end;

end.
